﻿using AIWolf.Lib;

namespace WhiteWolf.Arrangement
{
    public class ComingOut
    {

        /// <summary>カミングアウトしたエージェント</summary>
        public Agent Agent { get; }

        /// <summary>カミングアウトした役職</summary>
        public Role Role { get; }

        /// <summary>カミングアウトを行った発話</summary>
        public IUtterance ComingOutTalk { get; }

        /// <summary>カミングアウトを取り消した発話。取り消しが行われていなければnull。</summary>
        public IUtterance CancelTalk { get; private set; }

        /// <summary>最新データ時点で有効なCOか</summary>
        public bool IsEnable => CancelTalk == null;


        public ComingOut(Agent agent, Role role, IUtterance comingOutTalk)
        {
            Agent = agent;
            Role = role;
            ComingOutTalk = comingOutTalk;
        }

        public void Cancel(IUtterance cancelTalk)
        {
            CancelTalk = cancelTalk;
        }


        public override string ToString()
        {
            return Agent.AgentIdx + " is " + Role.ToString();
        }

    }
}
