﻿using AIWolf.Lib;

namespace WhiteWolf.Arrangement
{
    public class ContentUtterance : IContentUtterance
    {

        public int Idx { get; }

        public int Day { get; }

        public int Turn { get; }

        public Agent Agent { get; }

        public string Text { get; }

        public Content Content { get; }


        public ContentUtterance(int idx, int day, int turn, Agent agent, string text, ITalkCorder corder)
        {
            Idx = idx;
            Day = day;
            Turn = turn;
            Agent = agent;
            Text = text;
            Content = corder.Cord(text);
        }

        public ContentUtterance(IUtterance utterance, ITalkCorder corder) : this(
            idx: utterance.Idx,
            day: utterance.Day,
            turn: utterance.Turn,
            agent: utterance.Agent,
            text: utterance.Text,
            corder: corder
            )
        {
        }

    }
}
