﻿using AIWolf.Lib;
using WhiteWolf.Arrangement;

namespace WhiteWolf.Guess
{
    class PartSingleAgentWolfGuess : IPartSingleAgentGuess
    {
        public Agent Agent { get; }
        public double Plausibility { get; }

        public bool IsMatchCondition(IPattern pattern)
        {
            return (pattern.IsWerewolfBits & (1 << (Agent.AgentIdx - 1))) != 0;
        }

        public PartSingleAgentWolfGuess(Agent agent, double plausibility)
        {
            Agent = agent;
            Plausibility = plausibility;
        }
    }

    class PartSingleAgentNotWolfGuess : IPartSingleAgentGuess
    {
        public Agent Agent { get; }
        public double Plausibility { get; }

        public bool IsMatchCondition(IPattern pattern)
        {
            return (pattern.IsWerewolfBits & (1 << (Agent.AgentIdx - 1))) == 0;
        }

        public PartSingleAgentNotWolfGuess(Agent agent, double plausibility)
        {
            Agent = agent;
            Plausibility = plausibility;
        }
    }

    class PartSingleAgentPossessedGuess : IPartSingleAgentGuess
    {
        public Agent Agent { get; }
        public double Plausibility { get; }

        public bool IsMatchCondition(IPattern pattern)
        {
            return (pattern.IsPossessedBits & (1 << (Agent.AgentIdx - 1))) != 0;
        }

        public PartSingleAgentPossessedGuess(Agent agent, double plausibility)
        {
            Agent = agent;
            Plausibility = plausibility;
        }
    }

    class PartSingleAgentWolfSideGuess : IPartSingleAgentGuess
    {
        public Agent Agent { get; }
        public double Plausibility { get; }

        public bool IsMatchCondition(IPattern pattern)
        {
            return (pattern.IsWerewolfTeamBits & (1 << (Agent.AgentIdx - 1))) != 0;
        }

        public PartSingleAgentWolfSideGuess(Agent agent, double plausibility)
        {
            Agent = agent;
            Plausibility = plausibility;
        }
    }
}
