﻿using AIWolf.Lib;
using WhiteWolf.ActionPlan;
using WhiteWolf.Arrangement;
using WhiteWolf.Guess;
using WhiteWolf.Player;
using WhiteWolf.Talk;

namespace WhiteWolf.Sample
{
    public class SampleWhiteWolfPlayer : AbstractWhiteWolfPlayer
    {
        public override string Name => "SampleWhiteWolfPlayer";

        private IGuesser guesser = new SampleGuesser();
        protected override IGuesser Guesser => guesser;

        private IActionPlanner actionPlanner = new SampleActionPlanner();
        protected override IActionPlanner ActionPlanner => actionPlanner;

        ITalkGenerator talkGenerator = new SampleTalkGenerator();
        protected override ITalkGenerator TalkGenerator => talkGenerator;

        ITalkGenerator whisperGenerator = new DummyTalkGenerator();
        protected override ITalkGenerator WhisperGenerator => whisperGenerator;
    }


    class DummyTalkGenerator : ITalkGenerator
    {
        public string GetTalkText(ITotalityGameInfo gameInfo, ITotalGuess guess, IActionPlan actionPlan)
        {
            return Content.OVER.Text;
        }
    }


}
